<!DOCTYPE html>
<html lang="en">
<head>
	<meta charset="UTF-8">
	<title>Test</title>
	<script src="/leaflet/leaflet-src.js"></script>
	<script src="/leaflet/leaflet.js"></script>
	<link rel="stylesheet" href="/leaflet/leaflet.css">
	<style>
		.leaflet-popup {
			bottom: 20px !important;
		}
		li {
			margin: 0 10px;
			cursor: pointer;
		}
		li:hover, li.selected {
			background-color: #AAA;
		}
	</style>
</head>
<body>
	<div>
		<div id="map" style="height: 600px"></div>
		<div id="POIs">

		</div>
	</div>
</body>
<script>

	function getDatas() {
		return fetch(`${process.env.VUE_APP_BACKEND_URL}/tourCity`, {
			method: "POST",
			headers: {
				"Content-Type": "application/json"
			},
			body: JSON.stringify({
				"codeCommune": "75056",
				"nbDays": 4,
				"nbStepsByDay": {
					"all": 2
				},
				"minimumDurationByStep": "01:00",
				"interests": [
					"museum",
					"tourguide",
					"attraction",
					"activities",
					"events",
					"garden",
					"regionalcuisine",
					"sights",
					"theater",
					"artgallerie",
					"musicvenue",
					"nightclub",
					"park",
					"hiking",
					"historicplace",
					"historic",
					"nature",
					"publicplace",
					"church",
					"temple",
					"gastropub"
				],
				"interestsRestaurant": [
					"pub",
					"bar",
					"food",
					"supermarket",
					"gastropub",
					"university",
					"schools",
					"liquor",
					"seafood",
					"library",
					"events",
					"club",
					"tapas",
					"regionalcuisine",
					"nightlife",
					"fastfood",
					"museum",
					"artgallerie",
				],
				"categoriesHostel": [7314008,7314005]
			})
		})
	}

	const map = L.map('map').setView([47.53092519322762, 2.3734923973713276], 6);

	L.tileLayer('https://{s}.tile.openstreetmap.org/{z}/{x}/{y}.png', {
		attribution: '&copy; <a href="/copyright">OpenStreetMap</a> contributors'
	}).addTo(map);


	const Icon = L.Icon.extend({
		options: {}
	});

	const redIcon = new Icon({
		iconUrl: '/images/red-marker.ico',
		shadowUrl: '/leaflet/images/marker-shadow.png'
	});

	const greenIcon = new Icon({
		iconUrl: '/images/green-marker.ico',
		shadowUrl: '/leaflet/images/marker-shadow.png'
	});

	function traceContour(contour) {
		const scale = 5;
		for (let i = 0;i<contour.length;i+=scale) {
			if (contour[i][0] instanceof Array) {
				traceContour(contour[i]);
				continue;
			}
			const A = i;
			const B = Math.min(i+scale,contour.length-1)
			const [lng1,lat1] = contour[A];
			const [lng2,lat2] = contour[B];
			L.polyline([
				L.latLng(lat1,lng1),
				L.latLng(lat2,lng2),
			], {
				color: 'red'
			}).addTo(map)
		}
	}


	getDatas().then(res => res.json()).then(async ({contour,road,hostels,restaurantPositions}) => {

		/*const scale = 5;
		for (const road of roads) {
			for (let i=0;i<road.length-1;i+=scale) {
				const A = i;
				const B = Math.min(i+scale,road.length-1)
				const [lng1,lat1] = road[A];
				const [lng2,lat2] = road[B];
				L.polyline([
					L.latLng(lat1,lng1),
					L.latLng(lat2,lng2),
				], {
					color: 'blue'
				}).addTo(map)
			}
		}*/

		for (const {POIIndex,restaurants} of restaurantPositions) {
			for (const {name,lat,lng} of restaurants) {
				L.marker([lat, lng]).addTo(map)
						.bindPopup(name+" (restaurant after POI "+(parseInt(POIIndex)+1)+")")
						.openPopup();
			}
		}



		/*const A = topLeft;
		const B = {lat: topLeft.lat, lng: btmRight.lng};
		const C = btmRight;
		const D = {lat: btmRight.lat, lng: topLeft.lng};

		for (const [{lat: lat1,lng: lng1},{lat: lat2,lng: lng2}] of [[A,B],[B,C],[C,D],[D,A]]) {
			L.polyline([
				L.latLng(lat1,lng1),
				L.latLng(lat2,lng2),
			], {
				color: 'green'
			}).addTo(map)
		}*/
		for (const hostel of hostels) {
			const {lat, lng, name} = hostel;
			L.marker([lat, lng]).addTo(map)
					.setIcon(greenIcon)
					.bindPopup(name);
		}

		traceContour(contour);

		document.getElementById("POIs").innerHTML = "";
		const ul = document.createElement("ul");

		let i = 0;
		for (const {lat,lng,name,tags,category,rank} of road) {
			const marker = L.marker([lat,lng]).addTo(map)
					.setIcon(redIcon)
					.bindPopup(name+" ("+(i+1)+") ["+category+"] ("+tags.join(",")+") rank: "+rank);

			const li = document.createElement("li");
			li.innerText = name+" ("+(i+1)+") ["+category+"] ("+tags.join(",")+") rank: "+rank;
			li.onclick = () => {
				marker.openPopup();
				for (const otherLi of document.querySelectorAll("li"))
					otherLi.classList.remove("selected");
				li.classList.add("selected");
			}
			ul.appendChild(li);

			i ++;
		}
		document.getElementById("POIs").appendChild(ul);
	});
</script>
</html>
